// Copyright (C) 2007 XtractPro (Data Extraction Magazine)
// http://www.xtractpro.com, support@xtractpro.com
//
// This code is provided AS IS, with NO WARRANTY expressed or implied.
// Any use of this free open source code is at your own risk.
//
// You are hereby granted the right to use it and change it,
// provided that you acknowledge XtractPro somewhere in your
// source files, documentation, web site and application.
// MessageBox.Show("Text message");

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace XtractPro.Multimedia
{
    /// <summary>
    /// Very simple implementation of the CAPTCHA Image Generator,
    /// which allows customization of properties of a CaptchaImage
    /// _image instance through a propGrid PropertyGrid control.
    /// The image will be passed from _image's Image property
    /// in a pctImage PictureBox control, each time the user clicks
    /// on it. On double-click, setting the Text property of the _image
    /// instance to an empty string will actually generate a new random text.
    /// </summary>
    public partial class MainForm : Form
    {
        private CaptchaImage _image;

        public MainForm()
        {
            InitializeComponent();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            propGrid.SelectedObject = _image = new CaptchaImage();
            pctImage.Image = _image.Image;
        }

        private void Save_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                _image.Image.Save(saveFileDialog1.FileName, System.Drawing.Imaging.ImageFormat.Png);
            }
        }

        private void Exit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void Captcha_Click(object sender, EventArgs e)
        {
            pctImage.Image = _image.Image;
        }

        private void Random_Click(object sender, EventArgs e)
        {
            Random _random = new Random();
            string _text = "";
            for (int i = 0; i < _image.Length; i++)
            {
                char _char;
                do
                    _char = _image.CharacterSet[_random.Next(0, _image.CharacterSet.Length)];
                // don't think this works
                while (_image.Unique && _image.Length <= _image.CharacterSet.Length && _image.TextString.IndexOf(_char) >= 0);
                _text += _char;
            }
            _image.TextString = _text;
            propGrid.Refresh();
        }
    }
}